'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('../../../src/stylus/components/_labels.styl');

var _colorable = require('../../mixins/colorable');

var _colorable2 = _interopRequireDefault(_colorable);

var _helpers = require('../../util/helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Mixins
exports.default = {
  functional: true,

  name: 'v-label',

  props: {
    absolute: Boolean,
    color: {
      type: [Boolean, String],
      default: 'primary'
    },
    disabled: Boolean,
    focused: Boolean,
    for: String,
    left: {
      type: [Number, String],
      default: 0
    },
    right: {
      type: [Number, String],
      default: 'auto'
    },
    value: Boolean
  },

  render: function render(h, _ref) {
    var children = _ref.children,
        listeners = _ref.listeners,
        props = _ref.props;

    var data = {
      staticClass: 'v-label',
      'class': {
        'v-label--active': props.value,
        'v-label--is-disabled': props.disabled
      },
      attrs: {
        for: props.for,
        'aria-hidden': !props.for
      },
      on: listeners,
      style: {
        left: (0, _helpers.convertToUnit)(props.left),
        right: (0, _helpers.convertToUnit)(props.right),
        position: props.absolute ? 'absolute' : 'relative'
      }
    };

    if (props.focused) {
      data.class = _colorable2.default.methods.addTextColorClassChecks(data.class, props.color);
    }

    return h('label', data, children);
  }
};

// Helpers
// Styles