'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('../../../src/stylus/components/_messages.styl');

var _colorable = require('../../mixins/colorable');

var _colorable2 = _interopRequireDefault(_colorable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Styles
exports.default = {
  name: 'v-messages',

  mixins: [_colorable2.default],

  props: {
    value: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  },

  computed: {
    classes: function classes() {
      return this.addTextColorClassChecks();
    }
  },

  methods: {
    genChildren: function genChildren() {
      var _this = this;

      return this.$createElement('transition-group', {
        staticClass: 'v-messages__wrapper',
        props: {
          name: 'slide-y-transition',
          tag: 'div'
        }
      }, this.value.map(function (m) {
        return _this.genMessage(m);
      }));
    },
    genMessage: function genMessage(key) {
      return this.$createElement('div', {
        staticClass: 'v-messages__message',
        key: key
      }, key);
    }
  },

  render: function render(h) {
    return h('div', {
      staticClass: 'v-messages',
      'class': this.classes
    }, [this.genChildren()]);
  }
};

// Mixins