'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ripple = require('../directives/ripple');

var _ripple2 = _interopRequireDefault(_ripple);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @mixin */
exports.default = {
  name: 'rippleable',

  directives: { Ripple: _ripple2.default },

  props: {
    ripple: {
      type: [Boolean, Object],
      default: true
    }
  },

  methods: {
    genRipple: function genRipple() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!this.ripple) return null;

      data.staticClass = 'v-input--selection-controls__ripple';

      if (this.rippleClasses) data.staticClass += ' ' + this.rippleClasses;

      data.directives = data.directives || [];
      data.directives.push({
        name: 'ripple',
        value: this.ripple && !this.disabled && { center: true }
      });
      data.on = Object.assign({
        click: this.onChange
      }, this.$listeners);

      return this.$createElement('div', data);
    },
    onChange: function onChange() {}
  }
};